# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

Name:           mojo-signatures
Version:        1.1
Release:        0.5.svn11457.1%{?dist}
Epoch:          0
Summary:        Mojo API signatures project
Group:          Development/Libraries
License:        MIT
URL:            http://mojo.codehaus.org/
# we are using svn because upstream doesn't provide source tarballs
# and we want to have all available signatures together anyway (just
# in case)
# svn export http://svn.codehaus.org/mojo/trunk/signatures -r11457 mojo-signatures-1.1 && tar cjf mojo-signatures-1.1.tar.bz2 mojo-signatures-1.1
Source0:        %{name}-%{version}.tar.bz2
Patch0:         0001-pom.xml-files.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
# we should probably generate java15 signature with 1.5 jdk, but this
# doesn't work with gcj. The signatures are probably incorrect because
# of this, but at least they exist and noone complained yet :-)
# specific release required for handling "signature" packaging
Requires:       jpackage-utils
Requires:       maven2
Requires:       mojo-parent
# specific release required for objectweb-asm dependency in pom.xml
BuildRequires:  animal-sniffer >= 1.6-3
BuildRequires:  jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-install
BuildRequires:  cobertura-maven-plugin
BuildRequires:  objectweb-asm
BuildRequires:  mojo-parent
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The API Signatures project contains a number of projects which
generate signatures of various APIs, such as the Java Runtime. These
signatures are generated by and consumed by the Animal Sniffer
project.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
for i in signatures-parent java15 java16; do pushd $i
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate
popd; done

%install
rm -rf %{buildroot}

install -d -m 755 %{buildroot}%{_mavenpomdir}
install -d -m 755 %{buildroot}%{_javadir}/%{name}

install -pm 644 signatures-parent/pom.xml \
    %{buildroot}%{_mavenpomdir}/JPP.%{name}-parent.pom

for sig in java15 java16;do
   pushd $sig
      install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-$sig.pom
      install -pm 644 target/*signature %{buildroot}%{_javadir}/%{name}/$sig-%{version}.signature
      %add_to_maven_depmap org.codehaus.mojo.signature $sig %{version} JPP/%{name} $sig
   popd
done

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for sig in *-%{version}*; do ln -s ${sig} `echo $sig| sed "s|-%{version}||g"`; done)

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/%{name}
%{_javadir}*/%{name}/java15-1.1.signature
%{_javadir}*/%{name}/java15.signature
%{_javadir}*/%{name}/java16-1.1.signature
%{_javadir}*/%{name}/java16.signature
%{_mavenpomdir}/JPP.%{name}-java15.pom
%{_mavenpomdir}/JPP.%{name}-java16.pom
%{_mavenpomdir}/JPP.%{name}-parent.pom
%{_mavendepmapfragdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Jul 11 2011 David Walluck <dwalluck@redhat.com> 0:1.1-0.5.svn11457.1
- release (based on Fedora 1.1-0.5.svn11457)
